<template>
  <div class="app-container">
    <el-card>
      <div>
         <el-button type="primary" icon="el-icon-plus" @click="handleCreate"
        >新增项目</el-button
      >
      <el-input
              v-model="listQuery.search"
              placeholder="项目名称"
              style="width: 300px"
              class="filter-item"
              @keyup.enter.native="handleFilter"
            />
            <el-button
              class="filter-item"
              type="primary"
              icon="el-icon-search"
              @click="handleFilter"
              >搜索</el-button
            >
            <el-button
              class="filter-item"
              type="primary"
              icon="el-icon-refresh-left"
              @click="resetFilter"
              >重置</el-button
            >
    </div>
  
    </el-card>
    <el-card style="margin-top: 2px">
      <el-table
        v-loading="listLoading"
        :data="testitemList.results"
        border
        fit
        stripe
        highlight-current-row
        max-height="600"
      >
        <el-table-column type="index" width="50" />
        <el-table-column label="项目名称">
          <template slot-scope="scope">{{ scope.row.name }}</template>
        </el-table-column>
       
        <el-table-column label="条款号">
          <template slot-scope="scope">{{ scope.row.term_number }}</template>
        </el-table-column>
         <el-table-column label="标准名称">
          <template slot-scope="scope">{{ scope.row.standard_.name }}</template>
        </el-table-column>
          <el-table-column label="标准编号">
          <template slot-scope="scope">{{ scope.row.standard_.number }}</template>
        </el-table-column>
         
  <el-table-column label="创建时间">
          <template slot-scope="scope">{{ scope.row.create_time }}</template>
        </el-table-column>
        <el-table-column
          align="center"
          label="操作"
          width="220px"
        >
          <template slot-scope="scope">
           
            <el-link
              v-if="checkPermission(['warehouse_update'])"
              @click="handleEdit(scope)"
              >编辑</el-link
            >
            <el-link
              v-if="checkPermission(['warehouse_delete'])"
              type="danger"
              @click="handleDelete(scope)"
              >删除</el-link
            >
          </template>
        </el-table-column>
      </el-table>
      <pagination
        v-show="testitemList.count > 0"
        :total="testitemList.count"
        :page.sync="listQuery.page"
        :limit.sync="listQuery.page_size"
        @pagination="getList"
      />
    </el-card>
    <el-dialog
      :visible.sync="dialogVisible"
      :title="dialogType === 'edit' ? '编辑项目' : '新增项目'"
    >
      <el-form
        ref="Form"
        :model="testitem"
        label-width="80px"
        label-position="right"
        :rules="rule1"
      >
        <el-form-item label="项目名称" prop="name">
          <el-input v-model="testitem.name" placeholder="项目名称" />
        </el-form-item>
        <el-form-item label="条款号" prop="term_number">
          <el-input v-model="testitem.term_number" placeholder="条款号" />
        </el-form-item>
         <el-form-item label="标准" prop="standard">
          <el-select  style="width: 100%" v-model="testitem.standard" placeholder="请选择">
             <el-option
                v-for="item in options"
                :key="item.value"
                :label="item.label"
               :value="item.value">
              </el-option>
          </el-select>
        </el-form-item>
        
        
      </el-form>
      <div style="text-align: right">
        <el-button type="danger" @click="dialogVisible = false">取消</el-button>
        <el-button type="primary" @click="confirm('Form')">确认</el-button>
      </div>
    </el-dialog>
  </div>
</template>
<script>
import { getTestitemList, createTestitem,updateTestitem,deleteTestitem,getStandardList } from "@/api/qm";
import checkPermission from "@/utils/permission";


import { genTree } from "@/utils";
import Pagination from "@/components/Pagination"; // secondary package based on el-pagination
const defaultetestitem = {
};
export default {
  components: { Pagination },
  data() {
    return {
      testitem: defaultetestitem,
    testitemList: {
        count: 0,
      },
       listQuery: {
        page: 1,
        page_size: 20,
      },
       options:[],
      listLoading: true,
      dialogVisible: false,
      dialogType: "new",
      rule1: {
        name: [{ required: true, message: "请输入", trigger: "blur" }],
        term_number: [{ required: true, message: "请输入", trigger: "blur" }],
      },
    };
  },
  computed: {},
  watch: {},
  created() {
    this.getList();
     this.getLists()
  },
  methods: {
    checkPermission,
    //列表
    getList() {
      this.listLoading = true;
      getTestitemList(this.listQuery).then((response) => {
        if (response.data) {
          this.testitemList = response.data;
        }
        this.listLoading = false;
      });
    },
   
      getLists() {
      
      getStandardList({pageoff:true}).then((response) => {
        
          this.options = genTree(response.data);
       
      });
    },
   
    handleFilter() {
      this.listQuery.page = 1;
      this.getList();
    },
    resetFilter() {
      this.listQuery = {
        page: 1,
        page_size: 20,
      }
      this.getList();
    },
    handleCreate() {
      this.testitem = Object.assign({}, defaultetestitem);
      this.dialogType = "new";
      this.dialogVisible = true;
      this.$nextTick(() => {
        this.$refs["Form"].clearValidate();
      });
    },
   
    handleEdit(scope) {
      this.testitem = Object.assign({}, scope.row); // copy obj
      this.dialogType = "edit";
      this.dialogVisible = true;
      this.$nextTick(() => {
        this.$refs["Form"].clearValidate();
      });
    },
    handleDelete(scope) {
      this.$confirm("确认删除?", "警告", {
        confirmButtonText: "确认",
        cancelButtonText: "取消",
        type: "error",
      })
        .then(async () => {
          await deleteTestitem(scope.row.id);
          this.getList();
          this.$message.success("成功");
        })
        .catch((err) => {
          console.error(err);
        });
    },
   
    async confirm(form) {
      this.$refs[form].validate((valid) => {
        if (valid) {
          const isEdit = this.dialogType === "edit";
          if (isEdit) {
            updateTestitem(this.testitem.id, this.testitem).then((res) => {
              if (res.code >= 200) {
                this.getList();
                this.dialogVisible = false;
                this.$message.success("成功");
              }
            });
          } else {
            createTestitem(this.testitem).then((res) => {
              if (res.code >= 200) {
                this.getList();
                 this.dialogVisible = false;
                this.$message.success("成功");
              }
            });
          }
        } else {
          return false;
        }
      });
    },
  },
};
</script>
